program nebo;
uses crt, graph;

const POCET      =   50;
      MAX_POSUN  =    3;
      MAX_R      =    3;
      SLEEP      = 1000; (* zmenit podla rychlosti CPU *)
      SLEEP_SKOK =  200; (* kurzoriada *)

type hviezda_typ = record
                     x       : word;
                     y       : integer; (* kurzoriada *)
                     r       : word;
                     posun_x : word;
                     color   : word;
                   end;

var max_x, max_y, max_color, momentik : word;
    hviezda : array[0..POCET] of hviezda_typ;
    bulo : boolean;
    p_y : shortint;

procedure initnebo;
var i : word;
    gD, gM, eC : integer;
begin
  gD:=detect;
  initgraph(gD, gM, '');
  eC:=graphresult;
  if eC<>grOk then begin
    writeln('Carovala ryba aby bola chyba ', grapherrormsg(eC));
    halt(1);
  end;
  randomize;
  max_x:=getmaxx;
  max_y:=getmaxy;
  max_color:=getmaxcolor;
  p_y:=0;
  momentik:=SLEEP;
  for i:=1 to POCET do begin
    hviezda[i].x:=random(max_x+1);           (* moze byt aj nula *)
    hviezda[i].y:=random(max_y+1);           (* moze byt aj nula *)
    hviezda[i].r:=random(MAX_R)+1;           (* nemoze byt nula  *)
    hviezda[i].posun_x:=random(MAX_POSUN)+1; (* nemoze byt nula  *)
    hviezda[i].color:=random(max_color)+1;   (* nemoze byt nula  *)
    setcolor(hviezda[i].color);
    setfillstyle(solidfill, hviezda[i].color);
    fillellipse(hviezda[i].x, hviezda[i].y, hviezda[i].r, hviezda[i].r);
  end;
end;

procedure bolatlacica;
var tlacica : word;
begin
  tlacica:=ord(readkey);
  case tlacica of
    72 : if p_y<MAX_POSUN then p_y:=p_y+1;
    80 : if p_y>-MAX_POSUN then p_y:=p_y-1;
    75 : if momentik+SLEEP_SKOK<65535 then momentik:=momentik+SLEEP_SKOK;
    77 : if momentik-SLEEP_SKOK>0 then momentik:=momentik-SLEEP_SKOK;
    27 : bulo:=false;  
  end;
end;

procedure idesmargit;
var i : word;
begin
  for i:=1 to POCET do begin
    setcolor(0);
    setfillstyle(solidfill, 0);
    fillellipse(hviezda[i].x, hviezda[i].y, hviezda[i].r, hviezda[i].r);

    hviezda[i].x:=hviezda[i].x+hviezda[i].posun_x;
    if hviezda[i].x>max_x then hviezda[i].x:=hviezda[i].x-max_x;

    hviezda[i].y:=hviezda[i].y+p_y*hviezda[i].posun_x;
    if hviezda[i].y>max_y then hviezda[i].y:=hviezda[i].y-max_y;
    if hviezda[i].y<0 then hviezda[i].y:=hviezda[i].y+max_y;

    setcolor(hviezda[i].color);
    setfillstyle(solidfill, hviezda[i].color);
    fillellipse(hviezda[i].x, hviezda[i].y, hviezda[i].r, hviezda[i].r);
  end;
end;

begin
  write('Hviezdna kurzoriada a escapeiada zacne po stisnuti si cohokolvek ');
  while not keypressed do begin end;
  initnebo;
  bulo:=true;
  while bulo do begin
    delay(momentik);
    idesmargit;
    if keypressed then bolatlacica;
  end;
  closegraph;
  writeln;
end.
                                      